e := 1;
q := 2^(2*e+1);
field := GF(q);
sigma := 2^(e+1);
o := One(field);
vectors := Union(List(field,s->List(field,t->[o,s*t+s^(sigma+2)+t^sigma,s,t])));;
Add(vectors,[0*o,o,0*o,0*o]);;
pg := PG(3,q);
tits_ovoid := List(vectors,x->VectorSpaceToElement(pg,x));;

tangent_lines := Filtered(Lines(pg),x->Number(tits,y->y in x)=1);;
tangent_planes := Filtered(Planes(pg),x->Number(tits,y->y in x)=1);;

klein := KleinCorrespondenceExtended(q);
points := List(tangent_lines,x->x^klein);;
prelines := List(tangent_planes,x->x^klein);;

span := Span(points);
prelines2 := List(prelines,x->Meet(x,span));;
prelines2[1];

kleinquadric := AmbientGeometry(Range(klein));
lines := List(prelines2,x->Embed(kleinquadric,x));
lines[1];

q4q := ParabolicQuadric(4,q);
em := NaturalEmbeddingBySubspace(q4q,kleinquadric,span);

q4qlines := List(lines,x->PreImageElm(em,x));;

duality := NaturalDuality(q4q);
tits_ovoid_in_w3 := List(q4qlines,x->x^duality);;
w3 := AmbientGeometry(Range(duality));

Collected(List(Lines(w3),x->Number(tits_ovoid_in_w3,y->y in x)));
