q := 3;

pg1 := PG(1,q^2);
pg3 := PG(3,q);

em := NaturalEmbeddingByFieldReduction(pg1,pg3);
spread := List(Points(pg1),x->x^em);;

klein := KleinCorrespondence(q);
kleinquadric := AmbientGeometry(Range(klein));
quadric_pts := List(spread,x->x^klein);;

pg5 := PG(5,q);
plane := First(Planes(Span(quadric_pts)),x->TypeOfSubspace(kleinquadric,x)="parabolic");
phi := PolarityOfProjectiveSpace(kleinquadric);
perpplane := plane^phi;
conic := Filtered(quadric_pts,x->x in plane);;
perpconic := Filtered(Points(kleinquadric),x->x in perpplane);;
ovoid := Union(perpconic,Difference(quadric_pts,conic));;

hall_spread := List(ovoid,x->PreImageElm(klein,x));

pg4 := PG(4,q);
inf := HyperplaneByDualCoordinates(pg4,[1,0,0,0,0]*Z(q)^0);
em := NaturalEmbeddingBySubspace(pg3,pg4,inf);
hall_spread_embedded := List(hall_spread,x->x^em);;

pointsi := Filtered(Points(pg4),x->not x in inf);;
pointsii := hall_spread_embedded;;

points := Union(pointsi,pointsii);;

linesa := Union(List(hall_spread_embedded,x->Filtered(Planes(x),y->not y in inf)));;
linesb := [inf];

pts := Union(pointsi,pointsii);;
lines := Union(linesa,linesb);;

group_inf := FiningStabiliser(ProjectivityGroup(pg4),inf);

hall_group := FiningSetwiseStabiliser(group_inf,hall_spread_embedded);

plane := GeneralisedPolygonByElements(pts,lines,\*,hall_group,OnProjSubspaces);

graph := IncidenceGraph(plane);;
LoadPackage("digraph");
digraph := Digraph(graph);
group := AutomorphismGroup(digraph);
Order(group);
Order(hall_group);
